# $Id: 02_get.t,v 1.1 2008/04/24 09:12:21 pythontech Exp $
use strict;
use Test::More tests => 6;

# FIXME
BEGIN {
    # Need Triples & QMap modules but want local Model & QMap
    # Put site libs at end of search path
    push @INC, '/home/pythontech/lib';
}
use PythonTech::Triples::Memory;
use PythonTech::QMap;
use PythonTech::Model;

my $rdftype = 'http://www.w3.org/1999/02/22-rdf-syntax-ns#type';

# Create test data
my $tr = PythonTech::Triples::Memory->new;
my @data = qw(
	    x:foo rdf:type xs:Thing
	    x:foo xs:name =Fooey
	    x:bar rdf:type xs:Stuff
	    x:bar xs:owner x:foo
);
map {s/^rdf:type$/$rdftype/} @data;

while (my($s,$p,$o) = splice(@data,0,3)) {
    $tr->add($s,$p,$o);
}

# Tests with no URI manipulation
my $model = PythonTech::Model->new(triples => $tr,
				   classmap => {},
				   dbqmap => undef,
				   extqmap => undef);

my $foo = $model->as_obj('x:foo');
my $bar = $model->as_obj('x:bar');
is($foo->GET('isa_xs:Thing'), 1, 'isa_');
is($foo->GET('isa_Wibble'), 0, 'isa_ fail');
is($foo->GET('p_wombat'), undef, 'p_ fail');
is($foo->GET('p_xs:name'), "Fooey", 'p_ literal');
is($bar->GET('p_xs:owner'), $foo, 'p_ obj');
is($foo->GET('r_xs:owner'), $bar, 'r_');
